﻿/**
 * @author kubaszek
 * Graph0 - superclass for graph
 */
 
 
class graph0 {

	public static var EN = 0;
	public static var PL = 1;
		public static var LANG_NUM = 2;
public static var lang_Id :Number = PL;

private var nX1:Number, nY1:Number, nXw:Number, nYh:Number;
private var nMarginL:Number, nMarginR :Number = 3;
private	var nMarginT :Number, nMarginB :Number;

public var mcTarget :MovieClip = null;
public var mcBckgrnd :MovieClip = null;

public var nDepth :Number = 0;//initiate with negative value

public var nLeft :Number = 0;
public var nTop  :Number = 0;
public var nWidth:Number = 20;
public var nHeight:Number = 30;

public var nDivX :Number = 5;
public var nDivY :Number = 6;


private var tfX_label:TextField = null;
private var tfY_label:TextField = null;
private	var tfHeader:TextField = null;
private var tfX_min:TextField = null;
private var tfX_max:TextField = null;
private var tfY_min:TextField = null;
private var tfY_max:TextField = null;

public static var my_fmt:TextFormat = null;
public static var HEADER_MARG_LR:Number = 8;
public static var SAMPLE_NUM_STR:String = "34.56";


function graph0( target :MovieClip, depth :Number ){
	//nMarginL = nMarginR = nMarginT = nMarginB = 5;
	this.mcTarget = target;
	this.nDepth = depth;
	if ( this.nDepth == 0 ) this.nDepth = this.mcBckgrnd.getNextHighestDepth();

	this.mcBckgrnd=this.mcTarget.createEmptyMovieClip("mcBckgrnd"+this.nDepth, this.nDepth);
	//trace("mcBckgrnd.initialized: " + target+" depth = "+depth , Log.INFO);
}

private function drawBkgBox(x1:Number, y1:Number, xW:Number, yH:Number):Void{//no lineStyle()
	this.mcBckgrnd.moveTo(x1, y1);
	this.mcBckgrnd.lineTo(x1+xW, y1);
	this.mcBckgrnd.lineTo(x1+xW, y1+yH);
	this.mcBckgrnd.lineTo(x1, y1+yH);
	this.mcBckgrnd.lineTo(x1, y1);
}

public static function insideBox( xP: Number, yP:Number, 
		x1:Number, y1:Number, xW:Number, yH:Number ) :Boolean {
	return (	( xP > x1 ) && ( xP < x1+xW ) && 
				( yP > y1 ) && ( yP < y1+yH )	)
}//public static function insideBox
		
public function drawBackground():Void {
	var metrics:Object = my_fmt.getTextExtent(SAMPLE_NUM_STR);

	nMarginL = metrics.textFieldWidth+3;
	nMarginB = metrics.textFieldHeight+3;
	nMarginT = metrics.textFieldHeight+4;

	//Border
	this.mcBckgrnd.lineStyle( 2, 0x0000cc, 30 );
	drawBkgBox(nLeft, nTop, nWidth, nHeight);
	
	nX1 = nLeft+nMarginL;
	nY1 = nTop+nMarginT;
	nXw = nWidth-nMarginL-nMarginR;
	nYh = nHeight-nMarginT-nMarginB;

	this.mcBckgrnd.lineStyle( 1, 0x0000cc, 100 );
	drawBkgBox( nX1, nY1, nXw, nYh );
	
	//Grid
	this.mcBckgrnd.lineStyle( 1, 0x0000cc, 30 );
	var i=0;
	var dx = nXw; if ( nDivX > 0 ) dx /= nDivX;
	var x = nX1+dx;
	while ( x < nX1+nXw ) {
		this.mcBckgrnd.moveTo(x, nY1);
		this.mcBckgrnd.lineTo(x, nY1+nYh);
		x += dx;
	}
	var dy = nYh; if ( nDivY > 0 ) dy /= nDivY;
	var y = nY1+dy;
	while ( y < nY1+nYh ) {
		this.mcBckgrnd.moveTo(nX1, y);
		this.mcBckgrnd.lineTo(nX1+nXw, y);
		y += dy;
	}

	this.mcBckgrnd.createTextField( "tfHeader", ++this.nDepth, 
		this.nX1+HEADER_MARG_LR, this.nY1-metrics.textFieldHeight-1, 
		(this.nXw-2*HEADER_MARG_LR)/*Width*/, 
		metrics.textFieldHeight);
	with ( this.mcBckgrnd.tfHeader ) {
		graph0.my_fmt.align = 'center';
		setNewTextFormat(graph0.my_fmt);
		textColor = 0x0F0FFF;
		textHeight = 20;
		border = true;
		borderColor=0xcccccc;
		//background =true;
		//backgroundColor=0xf000cc;
		text = 'Header';
		//type = 'input';
	}

	this.mcBckgrnd.createTextField( "tfX_label", ++this.nDepth, 
		this.nX1+metrics.textFieldWidth+4, this.nY1+this.nYh+1, 
		this.nXw-2*(metrics.textFieldWidth+4), metrics.textFieldHeight-2 );
	with ( this.mcBckgrnd.tfX_label ) {
		graph0.my_fmt.bold = true;
		setNewTextFormat(graph0.my_fmt);
		selectable = false;
	}

	this.mcBckgrnd.createTextField( "tfY_label", ++this.nDepth, 
		this.nX1-metrics.textFieldWidth, (this.nY1*2+this.nYh-metrics.textFieldHeight)/2, 
		metrics.textFieldWidth, metrics.textFieldHeight-2 );
	with ( this.mcBckgrnd.tfY_label ) {
		setNewTextFormat(graph0.my_fmt);
		selectable = false;
		graph0.my_fmt.bold = false;//default
	}

	//edit-enabled
	this.mcBckgrnd.createTextField( "tfX_min", ++this.nDepth, 
		this.nX1+1, this.nY1+this.nYh+1, 
		metrics.textFieldWidth, metrics.textFieldHeight-2 );
	with ( this.mcBckgrnd.tfX_min ) {
		graph0.my_fmt.align = 'left';
		setNewTextFormat(graph0.my_fmt);
		border = true;
		borderColor=0xcccccc;
		type = 'input';
	}
	this.mcBckgrnd.createTextField( "tfX_max", ++this.nDepth, 
		this.nX1+this.nXw-metrics.textFieldWidth-1, this.nY1+this.nYh+1, 
		metrics.textFieldWidth, metrics.textFieldHeight-2 );
	with ( this.mcBckgrnd.tfX_max ) {
		graph0.my_fmt.align = 'right';
		setNewTextFormat(graph0.my_fmt);
		border = true;
		borderColor=0xcccccc;
		type = 'input';
	}
	this.mcBckgrnd.createTextField( "tfY_min", ++this.nDepth, 
		this.nX1-metrics.textFieldWidth, this.nY1+this.nYh-metrics.textFieldHeight-1, 
		metrics.textFieldWidth-2, metrics.textFieldHeight-2 );
	with ( this.mcBckgrnd.tfY_min ) {
		setNewTextFormat(graph0.my_fmt);
		border = true;
		borderColor=0xcccccc;
		type = 'input';
	}
	this.mcBckgrnd.createTextField( "tfY_max", ++this.nDepth, 
		this.nX1-metrics.textFieldWidth, this.nY1, 
		metrics.textFieldWidth-2, metrics.textFieldHeight-2 );
	with ( this.mcBckgrnd.tfY_max ) {
		setNewTextFormat(graph0.my_fmt);
		border = true;
		borderColor=0xcccccc;
		type = "input";
		//variable = "mcBckgrnd.nY_max";
	}
	graph0.my_fmt.align = 'left';//default for the next use
}//public function drawBackground()


}//class graph0
